<%

# $Header: /u/cvsroot/nsd-modules/dqd_threadpool/examples/book/www/lookup.adp,v 1.2 2000/11/23 01:14:36 mayoff Exp $

# See LICENSE for copyright, license, and disclaimer.

    set form [ns_getform]
    if {$form != ""} {
	set isbn [ns_set get $form isbn]
    }
    if {$form == "" || $isbn == ""} {
	ns_returnredirect /
	ns_adp_abort
    }
    regsub -all -- {-} $isbn {} isbn

    # Submit one job for each bookstore.  Save all the job id's in a list.

    set jobs {}
    lappend jobs [dqd_threadpool create bookpool [list amazon_lookup $isbn]]
    lappend jobs [dqd_threadpool create bookpool [list bn_lookup $isbn]]
    lappend jobs [dqd_threadpool create bookpool [list 1bookstreet_lookup $isbn]]
    lappend jobs [dqd_threadpool create bookpool [list wordsworth_lookup $isbn]]

%><html>
    <head>
	<title>
	    Results for <%= $isbn %>
	</title>
    </head>
    <body>
	<h2>Results for <%= $isbn %></h2>
	<a href='/'>Back to ISBN entry screen.</a>
	<hr>

	<ul>
<%
    # Turn on streaming so the user can see the result of each job as
    # soon as it's ready.

    ns_adp_stream

    while {[llength $jobs] > 0} {

	# The wait command will return a list of two sublists.
	set pair [dqd_threadpool wait bookpool $jobs]

	# The first sublist is the list of job ids that have completed.
	set finished [lindex $pair 0]

	# The second sublist is the list of job ids that have not completed.
	set remaining [lindex $pair 1]

	foreach job $finished {

	    # The get command returns a list containing the status code
	    # and the return value from the job.
	    set pair [dqd_threadpool get bookpool $job]

	    # The first element in the list is the status code.
	    set code [lindex $pair 0]

	    # The second element in the list is the return value.
	    set result [lindex $pair 1]

	    # Our jobs always return a list as the return value.  The
	    # first result list element is the bookstore name.
	    set bookstore [ns_quotehtml [lindex $result 0]]

	    # The second result list element is a URL.
	    set link [lindex $result 1]

	    if {$code == 1} {

		# Code 1 means the job raised an error.

		set problem [ns_quotehtml [lindex $result 2]]
		ns_adp_puts "<li>Could not determine price at <a href='$link'>$bookstore</a>: $problem<br>\n"

	    } else {

		# Any other code (should actually be 2, which means
		# "return") is success.

		set title [ns_quotehtml [lindex $result 2]]
		set price [lindex $result 3]
		ns_adp_puts "<li>$price for \"$title\" at <a href='$link'>$bookstore</a><br>\n"

	    }
	}

	# We'll keep looping until there are no remaining jobs.
	set jobs $remaining
    }
%>
	</ul>
    </body>
</html>

